#!/bin/bash

ACTIVE="$1"
if [ -z "$ACTIVE" ]; then
  ACTIVE="production"
  echo "Use default profile: $ACTIVE"
fi

[ ! -d ~/run/ ] && mkdir -p ~/run

if [ -f ~/run/adscounter-api.pid ]; then
  echo "Server [adscounter-api] pid file has been exists!";
  exit
fi

SERVER_JAR=`ls ../lib/adscounter-api-1.18.4.jar`

# 动态生成环境变量名
PROJECT_NAME=adscounter-api  # 示例项目名，你可以替换为你的实际项目名
ENV_NAME=$(echo "$PROJECT_NAME" | sed 's/-/_/g')_heap_size

echo "Dynamic environment variable name: $ENV_NAME"

# 读取动态环境变量的值，如果不存在则使用默认值8g
HEAP_SIZE=$(eval echo \${$ENV_NAME})
if [ -z "$HEAP_SIZE" ]; then
  HEAP_SIZE=2g
fi

echo "Use heap size: $HEAP_SIZE"

exec "${JAVA_HOME}/bin/java" -server -Dspring.profiles.active=$ACTIVE -Xms${HEAP_SIZE} -Xmx${HEAP_SIZE} -XX:+HeapDumpOnOutOfMemoryError -jar ${SERVER_JAR} >/dev/null 2>&1 & echo $! > ~/run/adscounter-api.pid